<?php
require_once __DIR__ . '/../../../init.php';
require_once __DIR__ . '/../../../includes/gatewayfunctions.php';
require_once __DIR__ . '/../../../includes/invoicefunctions.php';
require_once __DIR__.'/vendor/autoload.php';
use WHMCS\Billing\Invoice;
use WHMCS\Billing\Payment\Transaction;
use Forgingblock\ApiClient;

    
$fb_name = 'forgingblock';

    
$gatewayParams  = getGatewayVariables($fb_name);

$json_res = file_get_contents('php://input');	
$resAr = json_decode($json_res, true);


$fb_invoice_id = $resAr['id'];
$trade = $gatewayParams['trade'];
$token = $gatewayParams['token'];
$testMode = $gatewayParams['testMode'];
if ($testMode == 'on') $payment_mode = 'test';
else $payment_mode = 'live';



$forgingblock = new ApiClient($payment_mode);
$forgingblock->SetValue('trade',  $trade);
$forgingblock->SetValue('token', $token);
$forgingblock->SetValue('invoice', $fb_invoice_id);

$trans_no = $fb_invoice_id;

	
$payres = $forgingblock->CheckInvoiceStatus();
$payment_status = $forgingblock->GetInvoiceStatus();
$invoice_id = $payres['order'];		




$dubplatetr = false;  

$transAr = Transaction::where('gateway', $fb_name)->where('transid', $trans_no)->get();
foreach ($transAr as $trans) {	
  $dubplatetr = true;  
}

$fee = 0;
$invoice = WHMCS\Billing\Invoice::find($invoice_id);
$total = $invoice->total;


if (($payment_status == 'paid') || ($payment_status == 'complete') || ($payment_status == 'confirmed')) {
	if (!$dubplatetr) {
		$transactionStatus = 'Successful';
    	addInvoicePayment(
        	$invoice_id,
        	$trans_no,
        	$total,
        	$fee,
        	$fb_name
    	);
		logTransaction($gatewayParams['name'], $resAr, $transactionStatus); 
	}	
}
else
{
	$transactionStatus = 'Failure';
	$errMsg = $transactionStatus.' - '. $payment_status;
	if (!$dubplatetr) {		
		logTransaction($gatewayParams['name'], $resAr,$errMsg);	
	}
	
}
exit();	
