<?php
require_once __DIR__ . '/../../../init.php';
require_once __DIR__ . '/../../../includes/gatewayfunctions.php';
require_once __DIR__ . '/../../../includes/invoicefunctions.php';
require_once __DIR__.'/vendor/autoload.php';
use WHMCS\Billing\Invoice;
use WHMCS\Billing\Payment\Transaction;
use Forgingblock\ApiClient;

    
$forgingblock = 'forgingblock';

    
$gatewayParams  = getGatewayVariables($forgingblock);


$trade = $gatewayParams['trade'];
$token = $gatewayParams['token'];
$testMode = $gatewayParams['testMode'];
if ($testMode == 'on') $payment_mode = 'test';
else $payment_mode = 'live';

$forgingblock = new ApiClient($payment_mode);
	$forgingblock->SetValue('trade',  $trade);
	$forgingblock->SetValue('token', $token);
	$forgingblock->SetValue('amount', round($_POST['amount'], 2));								
	$forgingblock->SetValue('currency',$_POST['currency']);		
	$forgingblock->SetValue('link', $_POST['link']);
	$forgingblock->SetValue('notification', $_POST['notification']);
	$forgingblock->SetValue('order', $_POST['order']);
	$res =  $forgingblock->CreateInvoice();	
	$InvoiceURL = $forgingblock->GetInvoiceURL();
	if ($InvoiceURL) {
		$fb_id = $res['id'];
		$_SESSION['fb_id'] = $fb_id;
		header('Location: '.$InvoiceURL);
	}
	else {
		echo  $forgingblock->GetError();
		exit;
	}
	


exit();	
